/ comp / gb.opengl / gl / frontface
Gl.FrontFace (gb.opengl)
Syntax

    STATIC SUB FrontFace ( Mode AS Integer )

### Define front- and back-facing polygons

#### Parameters

- Mode specifies the orientation of front-facing polygons. Gl.GL_CW and Gl.GL_CCW are accepted. The default value is Gl.GL_CCW.

#### Description

In a scene composed entirely of opaque closed surfaces, back-facing polygons are never visible. Eliminating these invisible polygons has the obvious benefit of speeding up the rendering of the image. Elimination of back-facing polygons is enabled and disabled with Gl.Enable and Gl.Disable using argument Gl.GL_CULL_FACE.

The projection of a polygon to window coordinates is said to have clockwise winding if an imaginary object following the path from its first vertex, its second vertex, and so on, to its last vertex, and finally back to its first vertex, moves in a clockwise direction about the interior of the polygon. The polygon's winding is said to be counterclockwise if the imaginary object following the same path moves in a counterclockwise direction about the interior of the polygon. Gl.FrontFace specifies whether polygons with clockwise winding in window coordinates, or counterclockwise winding in window coordinates, are taken to be front-facing. Passing Gl.GL_CCW to mode selects counterclockwise polygons as front-facing; Gl.GL_CW selects clockwise polygons as front-facing. By default, counterclockwise polygons are taken to be front-facing.

#### Errors

Gl.GL_INVALID_ENUM is generated if Mode is not an accepted value.
Gl.GL_INVALID_OPERATION is generated if Gl.FrontFace is called between a call to Gl.Begin and the corresponding call to Gl.End.

#### Associated Gets

Gl.GetFrontFace

### See also

Gl.CullFace , Gl.LightModel